/* Generated by re2c 0.14.3 on Thu May 20 09:07:24 2021 */
#line 1 "../snl.re"
/*************************************************************************\
Copyright (c) 2010-2015 Helmholtz-Zentrum Berlin f. Materialien
                        und Energie GmbH, Germany (HZB)
This file is distributed subject to a Software License Agreement found
in the file LICENSE that is included with this distribution.
\*************************************************************************/
/*************************************************************************\
                    Lexer specification/implementation
\*************************************************************************/
#include <assert.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#include "snl.h"
#include "main.h"
#include "parser.h"

#define	TOK_EOI		0

typedef unsigned char uchar;

#define	BSIZE	8192

#define	YYCTYPE			uchar
#define	YYCURSOR		cursor
#define	YYLIMIT			s->lim
#define	YYMARKER		s->ptr
#define	YYFILL(dummy)		cursor = fill(s, cursor);
#define	YYDEBUG(state, current) report("state = %d, current = %c\n", state, current);

#define	RET(i,r) {\
	s->cur = cursor;\
	t->str = r;\
	return TOK_ ## i;\
}

#define OPERATOR		RET
#define LITERAL(t,e,n) 		RET(t,n)
#define KEYWORD 		RET
#define TYPEWORD		RET
#define IDENTIFIER(t,e,n)	RET(t,n)
#define DELIMITER		RET

#define DONE			RET(EOI,"")

typedef struct Scanner {
	uchar	*bot;	/* pointer to bottom (start) of buffer */
	uchar	*tok;	/* pointer to start of current token */
	uchar	*end;	/* pointer to (temporary) end of current token */
	uchar	*ptr;	/* marker for backtracking (always > tok) */
	uchar	*cur;	/* saved scan position between calls to scan() */
	uchar	*lim;	/* pointer to one position after last read char */
	uchar	*top;	/* pointer to (one after) top of allocated buffer */
	uchar	*eof;	/* pointer to (one after) last char in file (or 0) */
	const char *file;	/* source file name */
	int	line;	/* line number */
	FILE	*in;
} Scanner;

static void scan_report(Scanner *s, const char *format, ...)
__attribute__((format(printf,2,3)));

static void scan_report(Scanner *s, const char *format, ...)
{
	va_list args;

	report_loc(s->file, s->line);
	va_start(args, format);
	fprintf(stderr, "lexical error: ");
	vfprintf(stderr, format, args);
	va_end(args);
}

/*
From the re2c docs:

   The generated code "calls" YYFILL(n) when the buffer needs (re)filling: at
   least n additional characters should be provided. YYFILL(n) should adjust
   YYCURSOR, YYLIMIT, YYMARKER and YYCTXMARKER as needed. Note that for typical
   programming languages n will be the length of the longest keyword plus one.

We also add a '\n' byte at the end of the file as sentinel.
*/
static uchar *fill(Scanner *s, uchar *cursor) {
	/* does not touch s->cur, instead works with argument cursor */
	if (!s->eof) {
		uint read_cnt;			/* number of bytes read */
		int garbage = s->tok - s->bot;	/* number of garbage bytes */
		int valid = s->lim - s->tok;	/* number of still valid bytes to copy */
		uchar *token = s->tok;		/* start of valid bytes */
		int space = (s->top - s->lim) + garbage;
						/* remaining space after garbage collection */
		int need_alloc = space < BSIZE;	/* do we need to allocate a new buffer? */

		assert(valid >= 0);

		/* anything below s->tok is garbage, collect it */
		if (garbage) {
#ifdef DEBUG
			report("fill: garbage=%u, need_alloc=%d\n", garbage, need_alloc);
#endif
			if (!need_alloc) {
				/* shift valid buffer content down to bottom of buffer */
				memmove(s->bot, token, (size_t)valid);
			}
			/* adjust pointers */
			s->tok = s->bot;	/* same as s->tok -= garbage */
			s->ptr -= garbage;
			cursor -= garbage;
			s->lim -= garbage;
			s->end -= garbage;
			/* invariant: s->bot, s->top, s->eof, s->lim - s->tok */
		}
		/* increase the buffer size if necessary, ensuring that we have
		   at least BSIZE bytes of free space to fill (after s->lim) */
		if (need_alloc) {
			uchar *buf;

			assert(s->lim - s->bot >= 0);
			buf = (uchar*) malloc(((size_t)(s->lim - s->bot) + BSIZE)*sizeof(uchar));
#ifdef DEBUG
			report("fill: need_alloc, bot: before=%p after=%p\n", s->bot, buf);
#endif
			memcpy(buf, token, (size_t)valid);
			s->tok = buf;
			s->end = &buf[s->end - s->bot];
			s->ptr = &buf[s->ptr - s->bot];
			cursor = &buf[cursor - s->bot];
			s->lim = &buf[s->lim - s->bot];
			s->top = s->lim + BSIZE;
			free(s->bot);
			s->bot = buf;
		}
		/* fill the buffer, starting at s->lim, by reading a chunk of
		   BSIZE bytes (or less if eof is encountered) */
		if ((read_cnt = fread(s->lim, sizeof(uchar), BSIZE, s->in)) != BSIZE) {
			if (ferror(s->in)) {
				perror("error reading input");
				exit(EXIT_FAILURE);
			}
			if (feof(s->in)) {
				s->eof = &s->lim[read_cnt];
				/* insert sentinel and increase s->eof */
				*(s->eof)++ = '\n';
			}
		}
		s->lim += read_cnt;	/* adjust limit */
	}
	return cursor;
}

/* alias strdup_from_to: duplicate string from start to (exclusive) stop */
static char *strdupft(uchar *start, uchar *stop) {
	char *result;
	size_t n;
	assert (stop - start >= 0);
	n = (size_t)(stop - start);
	result = malloc(n+1);
	memcpy(result, start, n);
	result[n] = 0;
	return result;
}

/*
 * Note: Linemarkers differ between compilers. The MS C preprocessor outputs
 * "#line <linenum> <filename>" directives, while gcc leaves off the "line".
 */

#line 184 "../snl.re"


static int scan(Scanner *s, Token *t) {
	uchar *cursor = s->cur;
	int in_c_code = 0;
	/*
	Note: Must use a temporary offset for (parts of) line_marker.
	Normally we use s->tok to remember start positions. But line_markers
	can appear nested inside c_code block tokens, so using s->tok for
	line_markers would destroy them.
	*/
	int line_marker_part = 0;

	s->end = 0;

snl:
	if (in_c_code)
		goto c_code;
	t->line = s->line;
	t->file = s->file;
	s->tok = cursor;


#line 198 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		/* table 1 .. 8: 0 */
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 194,   0, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		194, 130, 130, 130, 130, 130, 130, 128, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		175, 175, 175, 175, 175, 175, 175, 175, 
		171, 171, 130, 130, 130, 130, 130, 130, 
		130, 170, 170, 170, 170, 170, 170, 162, 
		162, 162, 162, 162, 178, 162, 162, 162, 
		162, 162, 162, 162, 162, 178, 162, 162, 
		162, 162, 162, 130, 128, 130, 130, 162, 
		130, 170, 170, 170, 170, 170, 170, 162, 
		162, 162, 162, 162, 178, 162, 162, 162, 
		162, 162, 162, 162, 162, 178, 162, 162, 
		162, 162, 162, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		130, 130, 130, 130, 130, 130, 130, 130, 
		/* table 9 .. 9: 256 */
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0, 128, 128,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};

	if ((YYLIMIT - YYCURSOR) < 9) YYFILL(9);
	yych = *YYCURSOR;
	switch (yych) {
	case '\t':
	case ' ':	goto yy4;
	case '\n':	goto yy2;
	case '\v':
	case '\f':	goto yy81;
	case '!':	goto yy57;
	case '"':	goto yy8;
	case '#':	goto yy6;
	case '%':	goto yy12;
	case '&':	goto yy49;
	case '\'':	goto yy36;
	case '(':	goto yy69;
	case ')':	goto yy71;
	case '*':	goto yy47;
	case '+':	goto yy43;
	case ',':	goto yy65;
	case '-':	goto yy45;
	case '.':	goto yy37;
	case '/':	goto yy10;
	case '0':	goto yy33;
	case '1':
	case '2':
	case '3':
	case '4':
	case '5':
	case '6':
	case '7':
	case '8':
	case '9':	goto yy35;
	case ':':	goto yy67;
	case ';':	goto yy59;
	case '<':	goto yy41;
	case '=':	goto yy55;
	case '>':	goto yy39;
	case '?':	goto yy79;
	case 'A':
	case 'B':
	case 'C':
	case 'D':
	case 'E':
	case 'F':
	case 'G':
	case 'H':
	case 'I':
	case 'J':
	case 'K':
	case 'L':
	case 'M':
	case 'N':
	case 'O':
	case 'P':
	case 'Q':
	case 'R':
	case 'S':
	case 'T':
	case 'U':
	case 'V':
	case 'W':
	case 'X':
	case 'Y':
	case 'Z':
	case '_':
	case 'g':
	case 'h':
	case 'j':
	case 'k':
	case 'n':
	case 'q':
	case 'x':
	case 'y':
	case 'z':	goto yy32;
	case '[':	goto yy73;
	case ']':	goto yy75;
	case '^':	goto yy51;
	case 'a':	goto yy14;
	case 'b':	goto yy16;
	case 'c':	goto yy17;
	case 'd':	goto yy18;
	case 'e':	goto yy19;
	case 'f':	goto yy20;
	case 'i':	goto yy21;
	case 'l':	goto yy22;
	case 'm':	goto yy23;
	case 'o':	goto yy24;
	case 'p':	goto yy25;
	case 'r':	goto yy26;
	case 's':	goto yy27;
	case 't':	goto yy28;
	case 'u':	goto yy29;
	case 'v':	goto yy30;
	case 'w':	goto yy31;
	case '{':	goto yy61;
	case '|':	goto yy53;
	case '}':	goto yy63;
	case '~':	goto yy77;
	default:	goto yy82;
	}
yy2:
	++YYCURSOR;
#line 207 "../snl.re"
	{
				if(cursor == s->eof) DONE;
				s->line++;
				goto snl;
			}
#line 379 "lexer.c"
yy4:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy403;
yy5:
#line 337 "../snl.re"
	{ goto snl; }
#line 387 "lexer.c"
yy6:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy393;
	} else {
		if (yych <= ' ') goto yy393;
		if (yych == 'l') goto yy396;
	}
yy7:
#line 338 "../snl.re"
	{ scan_report(s, "invalid character\n"); DONE; }
#line 400 "lexer.c"
yy8:
	++YYCURSOR;
#line 216 "../snl.re"
	{
				s->tok = s->end = cursor;
				goto string_const;
			}
#line 408 "lexer.c"
yy10:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '.') {
		if (yych == '*') goto yy391;
	} else {
		if (yych <= '/') goto yy388;
		if (yych == '=') goto yy386;
	}
#line 330 "../snl.re"
	{ OPERATOR(SLASH,	"/"); }
#line 419 "lexer.c"
yy12:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '<') {
		if (yych == '%') goto yy381;
	} else {
		if (yych <= '=') goto yy379;
		if (yych == '{') goto yy384;
	}
#line 331 "../snl.re"
	{ OPERATOR(MOD,		"%"); }
#line 430 "lexer.c"
yy14:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == 's') goto yy373;
	goto yy170;
yy15:
#line 285 "../snl.re"
	{ IDENTIFIER(NAME, identifier, strdupft(s->tok, cursor)); }
#line 438 "lexer.c"
yy16:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy368;
	goto yy170;
yy17:
	yych = *++YYCURSOR;
	if (yych == 'h') goto yy353;
	if (yych == 'o') goto yy354;
	goto yy170;
yy18:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy347;
	goto yy170;
yy19:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'l':	goto yy325;
	case 'n':	goto yy326;
	case 'v':	goto yy327;
	case 'x':	goto yy328;
	default:	goto yy170;
	}
yy20:
	yych = *++YYCURSOR;
	if (yych == 'l') goto yy312;
	if (yych == 'o') goto yy313;
	goto yy170;
yy21:
	yych = *++YYCURSOR;
	if (yych == 'f') goto yy293;
	if (yych == 'n') goto yy295;
	goto yy170;
yy22:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy289;
	goto yy170;
yy23:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy282;
	goto yy170;
yy24:
	yych = *++YYCURSOR;
	if (yych == 'p') goto yy276;
	goto yy170;
yy25:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy269;
	goto yy170;
yy26:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy263;
	goto yy170;
yy27:
	yych = *++YYCURSOR;
	switch (yych) {
	case 'e':	goto yy222;
	case 'h':	goto yy223;
	case 'i':	goto yy224;
	case 's':	goto yy225;
	case 't':	goto yy227;
	case 'y':	goto yy228;
	default:	goto yy170;
	}
yy28:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy212;
	if (yych == 'y') goto yy214;
	goto yy170;
yy29:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy183;
	if (yych == 'n') goto yy184;
	goto yy170;
yy30:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy179;
	goto yy170;
yy31:
	yych = *++YYCURSOR;
	if (yych == 'h') goto yy171;
	goto yy170;
yy32:
	yych = *++YYCURSOR;
	goto yy170;
yy33:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yybm[0+yych] & 16) {
		goto yy145;
	}
	if (yych == 'X') goto yy162;
	if (yych == 'x') goto yy162;
	goto yy161;
yy34:
#line 287 "../snl.re"
	{ LITERAL(INTCON, integer_literal, strdupft(s->tok, cursor)); }
#line 535 "lexer.c"
yy35:
	yyaccept = 2;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy143;
yy36:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == '\n') goto yy7;
	goto yy133;
yy37:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 1) {
		goto yy123;
	}
#line 323 "../snl.re"
	{ OPERATOR(PERIOD,	"."); }
#line 552 "lexer.c"
yy39:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '<') goto yy40;
	if (yych <= '=') goto yy117;
	if (yych <= '>') goto yy119;
yy40:
#line 333 "../snl.re"
	{ OPERATOR(GT,		">"); }
#line 561 "lexer.c"
yy41:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= ';') goto yy42;
	if (yych <= '<') goto yy113;
	if (yych <= '=') goto yy111;
yy42:
#line 332 "../snl.re"
	{ OPERATOR(LT,		"<"); }
#line 570 "lexer.c"
yy43:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '+') goto yy107;
	if (yych == '=') goto yy109;
#line 328 "../snl.re"
	{ OPERATOR(ADD,		"+"); }
#line 577 "lexer.c"
yy45:
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '<') {
		if (yych == '-') goto yy103;
	} else {
		if (yych <= '=') goto yy105;
		if (yych <= '>') goto yy101;
	}
#line 327 "../snl.re"
	{ OPERATOR(SUB,		"-"); }
#line 588 "lexer.c"
yy47:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy99;
#line 329 "../snl.re"
	{ OPERATOR(ASTERISK,	"*"); }
#line 594 "lexer.c"
yy49:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '&') goto yy95;
	if (yych == '=') goto yy97;
#line 324 "../snl.re"
	{ OPERATOR(AMPERSAND,	"&"); }
#line 601 "lexer.c"
yy51:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy93;
#line 334 "../snl.re"
	{ OPERATOR(CARET,	"^"); }
#line 607 "lexer.c"
yy53:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy91;
	if (yych == '|') goto yy89;
#line 335 "../snl.re"
	{ OPERATOR(VBAR,	"|"); }
#line 614 "lexer.c"
yy55:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy87;
#line 318 "../snl.re"
	{ OPERATOR(EQUAL,	"="); }
#line 620 "lexer.c"
yy57:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy85;
#line 325 "../snl.re"
	{ OPERATOR(NOT,		"!"); }
#line 626 "lexer.c"
yy59:
	++YYCURSOR;
#line 313 "../snl.re"
	{ DELIMITER(SEMICOLON,	";"); }
#line 631 "lexer.c"
yy61:
	++YYCURSOR;
#line 314 "../snl.re"
	{ DELIMITER(LBRACE,	"{"); }
#line 636 "lexer.c"
yy63:
	++YYCURSOR;
#line 315 "../snl.re"
	{ DELIMITER(RBRACE,	"}"); }
#line 641 "lexer.c"
yy65:
	++YYCURSOR;
#line 316 "../snl.re"
	{ DELIMITER(COMMA,	","); }
#line 646 "lexer.c"
yy67:
	++YYCURSOR;
#line 317 "../snl.re"
	{ OPERATOR(COLON,	":"); }
#line 651 "lexer.c"
yy69:
	++YYCURSOR;
#line 319 "../snl.re"
	{ DELIMITER(LPAREN,	"("); }
#line 656 "lexer.c"
yy71:
	++YYCURSOR;
#line 320 "../snl.re"
	{ DELIMITER(RPAREN,	")"); }
#line 661 "lexer.c"
yy73:
	++YYCURSOR;
#line 321 "../snl.re"
	{ DELIMITER(LBRACKET,	"["); }
#line 666 "lexer.c"
yy75:
	++YYCURSOR;
#line 322 "../snl.re"
	{ DELIMITER(RBRACKET,	"]"); }
#line 671 "lexer.c"
yy77:
	++YYCURSOR;
#line 326 "../snl.re"
	{ OPERATOR(TILDE,	"~"); }
#line 676 "lexer.c"
yy79:
	++YYCURSOR;
#line 336 "../snl.re"
	{ OPERATOR(QUESTION,	"?"); }
#line 681 "lexer.c"
yy81:
	yych = *++YYCURSOR;
	goto yy84;
yy82:
	yych = *++YYCURSOR;
	goto yy7;
yy83:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy84:
	if (yybm[256+yych] & 128) {
		goto yy83;
	}
	goto yy5;
yy85:
	++YYCURSOR;
#line 312 "../snl.re"
	{ OPERATOR(NE,		"!="); }
#line 701 "lexer.c"
yy87:
	++YYCURSOR;
#line 311 "../snl.re"
	{ OPERATOR(EQ,		"=="); }
#line 706 "lexer.c"
yy89:
	++YYCURSOR;
#line 308 "../snl.re"
	{ OPERATOR(OROR,	"||"); }
#line 711 "lexer.c"
yy91:
	++YYCURSOR;
#line 301 "../snl.re"
	{ OPERATOR(OREQ,	"|="); }
#line 716 "lexer.c"
yy93:
	++YYCURSOR;
#line 300 "../snl.re"
	{ OPERATOR(XOREQ,	"^="); }
#line 721 "lexer.c"
yy95:
	++YYCURSOR;
#line 307 "../snl.re"
	{ OPERATOR(ANDAND,	"&&"); }
#line 726 "lexer.c"
yy97:
	++YYCURSOR;
#line 299 "../snl.re"
	{ OPERATOR(ANDEQ,	"&="); }
#line 731 "lexer.c"
yy99:
	++YYCURSOR;
#line 296 "../snl.re"
	{ OPERATOR(MULEQ,	"*="); }
#line 736 "lexer.c"
yy101:
	++YYCURSOR;
#line 306 "../snl.re"
	{ OPERATOR(POINTER,	"->"); }
#line 741 "lexer.c"
yy103:
	++YYCURSOR;
#line 305 "../snl.re"
	{ OPERATOR(DECR,	"--"); }
#line 746 "lexer.c"
yy105:
	++YYCURSOR;
#line 295 "../snl.re"
	{ OPERATOR(SUBEQ,	"-="); }
#line 751 "lexer.c"
yy107:
	++YYCURSOR;
#line 304 "../snl.re"
	{ OPERATOR(INCR,	"++"); }
#line 756 "lexer.c"
yy109:
	++YYCURSOR;
#line 294 "../snl.re"
	{ OPERATOR(ADDEQ,	"+="); }
#line 761 "lexer.c"
yy111:
	++YYCURSOR;
#line 309 "../snl.re"
	{ OPERATOR(LE,		"<="); }
#line 766 "lexer.c"
yy113:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy115;
#line 303 "../snl.re"
	{ OPERATOR(LSHIFT,	"<<"); }
#line 772 "lexer.c"
yy115:
	++YYCURSOR;
#line 293 "../snl.re"
	{ OPERATOR(LSHEQ,	"<<="); }
#line 777 "lexer.c"
yy117:
	++YYCURSOR;
#line 310 "../snl.re"
	{ OPERATOR(GE,		">="); }
#line 782 "lexer.c"
yy119:
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '=') goto yy121;
#line 302 "../snl.re"
	{ OPERATOR(RSHIFT,	">>"); }
#line 788 "lexer.c"
yy121:
	++YYCURSOR;
#line 292 "../snl.re"
	{ OPERATOR(RSHEQ,	">>="); }
#line 793 "lexer.c"
yy123:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 1) {
		goto yy123;
	}
	if (yych <= 'L') {
		if (yych <= 'E') {
			if (yych >= 'E') goto yy126;
		} else {
			if (yych <= 'F') goto yy128;
			if (yych >= 'L') goto yy128;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'd') goto yy125;
			if (yych <= 'e') goto yy126;
			goto yy128;
		} else {
			if (yych == 'l') goto yy128;
		}
	}
yy125:
#line 290 "../snl.re"
	{ LITERAL(FPCON, floating_point_literal, strdupft(s->tok, cursor)); }
#line 821 "lexer.c"
yy126:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy129;
	} else {
		if (yych <= '-') goto yy129;
		if (yych <= '/') goto yy127;
		if (yych <= '9') goto yy130;
	}
yy127:
	YYCURSOR = YYMARKER;
	if (yyaccept <= 2) {
		if (yyaccept <= 1) {
			if (yyaccept == 0) {
				goto yy5;
			} else {
				goto yy7;
			}
		} else {
			goto yy34;
		}
	} else {
		if (yyaccept == 3) {
			goto yy125;
		} else {
			goto yy395;
		}
	}
yy128:
	yych = *++YYCURSOR;
	goto yy125;
yy129:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy127;
	if (yych >= ':') goto yy127;
yy130:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= '9') {
			if (yych <= '/') goto yy125;
			goto yy130;
		} else {
			if (yych == 'F') goto yy128;
			goto yy125;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'L') goto yy128;
			if (yych <= 'e') goto yy125;
			goto yy128;
		} else {
			if (yych == 'l') goto yy128;
			goto yy125;
		}
	}
yy132:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy133:
	if (yybm[0+yych] & 2) {
		goto yy132;
	}
	if (yych <= '\n') goto yy127;
	if (yych <= '\'') goto yy135;
yy134:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 4) {
		goto yy137;
	}
	if (yych <= 'e') {
		if (yych <= '>') {
			if (yych <= '"') {
				if (yych <= '!') goto yy127;
				goto yy132;
			} else {
				if (yych == '\'') goto yy132;
				goto yy127;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '?') goto yy132;
				if (yych <= '[') goto yy127;
				goto yy132;
			} else {
				if (yych <= '`') goto yy127;
				if (yych <= 'b') goto yy132;
				goto yy127;
			}
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'n') {
				if (yych <= 'f') goto yy132;
				if (yych <= 'm') goto yy127;
				goto yy132;
			} else {
				if (yych == 'r') goto yy132;
				goto yy127;
			}
		} else {
			if (yych <= 'v') {
				if (yych == 'u') goto yy127;
				goto yy132;
			} else {
				if (yych == 'x') goto yy136;
				goto yy127;
			}
		}
	}
yy135:
	yych = *++YYCURSOR;
	goto yy34;
yy136:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy139;
	}
	goto yy127;
yy137:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 4) {
		goto yy137;
	}
	if (yych <= '&') {
		if (yych == '\n') goto yy127;
		goto yy132;
	} else {
		if (yych <= '\'') goto yy135;
		if (yych == '\\') goto yy134;
		goto yy132;
	}
yy139:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 8) {
		goto yy139;
	}
	if (yych <= '&') {
		if (yych == '\n') goto yy127;
		goto yy132;
	} else {
		if (yych <= '\'') goto yy135;
		if (yych == '\\') goto yy134;
		goto yy132;
	}
yy141:
	yyaccept = 3;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych == 'E') goto yy152;
	if (yych == 'e') goto yy152;
	goto yy151;
yy142:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
yy143:
	if (yybm[0+yych] & 16) {
		goto yy145;
	}
	if (yych <= '9') {
		if (yych == '.') goto yy141;
		if (yych <= '/') goto yy34;
		goto yy142;
	} else {
		if (yych <= 'E') {
			if (yych <= 'D') goto yy34;
		} else {
			if (yych != 'e') goto yy34;
		}
	}
yy144:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych == '+') goto yy147;
		goto yy127;
	} else {
		if (yych <= '-') goto yy147;
		if (yych <= '/') goto yy127;
		if (yych <= '9') goto yy148;
		goto yy127;
	}
yy145:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 16) {
		goto yy145;
	}
	goto yy34;
yy147:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy127;
	if (yych >= ':') goto yy127;
yy148:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= '9') {
			if (yych <= '/') goto yy125;
			goto yy148;
		} else {
			if (yych == 'F') goto yy128;
			goto yy125;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'L') goto yy128;
			if (yych <= 'e') goto yy125;
			goto yy128;
		} else {
			if (yych == 'l') goto yy128;
			goto yy125;
		}
	}
yy150:
	yyaccept = 3;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 3) YYFILL(3);
	yych = *YYCURSOR;
yy151:
	if (yych <= 'K') {
		if (yych <= 'D') {
			if (yych <= '/') goto yy125;
			if (yych <= '9') goto yy150;
			goto yy125;
		} else {
			if (yych <= 'E') goto yy156;
			if (yych <= 'F') goto yy128;
			goto yy125;
		}
	} else {
		if (yych <= 'e') {
			if (yych <= 'L') goto yy128;
			if (yych <= 'd') goto yy125;
			goto yy156;
		} else {
			if (yych <= 'f') goto yy128;
			if (yych == 'l') goto yy128;
			goto yy125;
		}
	}
yy152:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy127;
	} else {
		if (yych <= '-') goto yy153;
		if (yych <= '/') goto yy127;
		if (yych <= '9') goto yy154;
		goto yy127;
	}
yy153:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy127;
	if (yych >= ':') goto yy127;
yy154:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= '9') {
			if (yych <= '/') goto yy125;
			goto yy154;
		} else {
			if (yych == 'F') goto yy128;
			goto yy125;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'L') goto yy128;
			if (yych <= 'e') goto yy125;
			goto yy128;
		} else {
			if (yych == 'l') goto yy128;
			goto yy125;
		}
	}
yy156:
	yych = *++YYCURSOR;
	if (yych <= ',') {
		if (yych != '+') goto yy127;
	} else {
		if (yych <= '-') goto yy157;
		if (yych <= '/') goto yy127;
		if (yych <= '9') goto yy158;
		goto yy127;
	}
yy157:
	yych = *++YYCURSOR;
	if (yych <= '/') goto yy127;
	if (yych >= ':') goto yy127;
yy158:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'K') {
		if (yych <= '9') {
			if (yych <= '/') goto yy125;
			goto yy158;
		} else {
			if (yych == 'F') goto yy128;
			goto yy125;
		}
	} else {
		if (yych <= 'f') {
			if (yych <= 'L') goto yy128;
			if (yych <= 'e') goto yy125;
			goto yy128;
		} else {
			if (yych == 'l') goto yy128;
			goto yy125;
		}
	}
yy160:
	yyaccept = 2;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 4) YYFILL(4);
	yych = *YYCURSOR;
yy161:
	if (yych <= 'L') {
		if (yych <= '7') {
			if (yych == '.') goto yy141;
			if (yych <= '/') goto yy34;
			goto yy160;
		} else {
			if (yych <= 'D') {
				if (yych <= '9') goto yy142;
				goto yy34;
			} else {
				if (yych <= 'E') goto yy144;
				if (yych <= 'K') goto yy34;
				goto yy167;
			}
		}
	} else {
		if (yych <= 'e') {
			if (yych == 'U') goto yy167;
			if (yych <= 'd') goto yy34;
			goto yy144;
		} else {
			if (yych <= 'l') {
				if (yych <= 'k') goto yy34;
				goto yy167;
			} else {
				if (yych == 'u') goto yy167;
				goto yy34;
			}
		}
	}
yy162:
	yych = *++YYCURSOR;
	if (yych <= '@') {
		if (yych <= '/') goto yy127;
		if (yych >= ':') goto yy127;
	} else {
		if (yych <= 'F') goto yy163;
		if (yych <= '`') goto yy127;
		if (yych >= 'g') goto yy127;
	}
yy163:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'T') {
		if (yych <= '@') {
			if (yych <= '/') goto yy34;
			if (yych <= '9') goto yy163;
			goto yy34;
		} else {
			if (yych <= 'F') goto yy163;
			if (yych != 'L') goto yy34;
		}
	} else {
		if (yych <= 'k') {
			if (yych <= 'U') goto yy165;
			if (yych <= '`') goto yy34;
			if (yych <= 'f') goto yy163;
			goto yy34;
		} else {
			if (yych <= 'l') goto yy165;
			if (yych != 'u') goto yy34;
		}
	}
yy165:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'U') {
		if (yych == 'L') goto yy165;
		if (yych <= 'T') goto yy34;
		goto yy165;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy34;
			goto yy165;
		} else {
			if (yych == 'u') goto yy165;
			goto yy34;
		}
	}
yy167:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'U') {
		if (yych == 'L') goto yy167;
		if (yych <= 'T') goto yy34;
		goto yy167;
	} else {
		if (yych <= 'l') {
			if (yych <= 'k') goto yy34;
			goto yy167;
		} else {
			if (yych == 'u') goto yy167;
			goto yy34;
		}
	}
yy169:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy170:
	if (yybm[0+yych] & 32) {
		goto yy169;
	}
	goto yy15;
yy171:
	yych = *++YYCURSOR;
	if (yych == 'e') goto yy172;
	if (yych == 'i') goto yy173;
	goto yy170;
yy172:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy177;
	goto yy170;
yy173:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 270 "../snl.re"
	{ KEYWORD(WHILE,	"while"); }
#line 1280 "lexer.c"
yy177:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 269 "../snl.re"
	{ KEYWORD(WHEN,		"when"); }
#line 1288 "lexer.c"
yy179:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'd') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 268 "../snl.re"
	{ TYPEWORD(VOID,	"void"); }
#line 1300 "lexer.c"
yy183:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy196;
	goto yy170;
yy184:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy185;
	if (yych == 's') goto yy186;
	goto yy170;
yy185:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy193;
	goto yy170;
yy186:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'd') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 267 "../snl.re"
	{ TYPEWORD(UNSIGNED,	"unsigned"); }
#line 1331 "lexer.c"
yy193:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 266 "../snl.re"
	{ TYPEWORD(UNION,	"union"); }
#line 1341 "lexer.c"
yy196:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	yych = *++YYCURSOR;
	if (yych <= '2') {
		if (yych == '1') goto yy199;
		goto yy170;
	} else {
		if (yych <= '3') goto yy200;
		if (yych != '8') goto yy170;
	}
	yych = *++YYCURSOR;
	if (yych == '_') goto yy209;
	goto yy170;
yy199:
	yych = *++YYCURSOR;
	if (yych == '6') goto yy205;
	goto yy170;
yy200:
	yych = *++YYCURSOR;
	if (yych != '2') goto yy170;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 277 "../snl.re"
	{ TYPEWORD(UINT32T,	"uint32_t"); }
#line 1373 "lexer.c"
yy205:
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 275 "../snl.re"
	{ TYPEWORD(UINT16T,	"uint16_t"); }
#line 1385 "lexer.c"
yy209:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 273 "../snl.re"
	{ TYPEWORD(UINT8T, 	"uint8_t"); }
#line 1395 "lexer.c"
yy212:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 264 "../snl.re"
	{ KEYWORD(TO,		"to"); }
#line 1403 "lexer.c"
yy214:
	yych = *++YYCURSOR;
	if (yych != 'p') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 265 "../snl.re"
	{ TYPEWORD(TYPENAME,	"typename"); }
#line 1423 "lexer.c"
yy222:
	yych = *++YYCURSOR;
	if (yych == 'q') goto yy258;
	goto yy170;
yy223:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy254;
	goto yy170;
yy224:
	yych = *++YYCURSOR;
	if (yych == 'z') goto yy249;
	goto yy170;
yy225:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 257 "../snl.re"
	{ KEYWORD(SS,		"ss"); }
#line 1443 "lexer.c"
yy227:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy236;
	if (yych == 'r') goto yy237;
	goto yy170;
yy228:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy170;
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 'Z') {
		if (yych <= '@') {
			if (yych <= '/') goto yy231;
			if (yych <= '9') goto yy169;
		} else {
			if (yych == 'Q') goto yy232;
			goto yy169;
		}
	} else {
		if (yych <= '`') {
			if (yych == '_') goto yy169;
		} else {
			if (yych == 'q') goto yy234;
			if (yych <= 'z') goto yy169;
		}
	}
yy231:
#line 263 "../snl.re"
	{ KEYWORD(SYNC,		"sync"); }
#line 1474 "lexer.c"
yy232:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 261 "../snl.re"
	{ KEYWORD(SYNCQ,	"syncQ"); }
#line 1482 "lexer.c"
yy234:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 262 "../snl.re"
	{ KEYWORD(SYNCQ,	"syncq"); }
#line 1490 "lexer.c"
yy236:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy246;
	goto yy170;
yy237:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy238;
	if (yych == 'u') goto yy239;
	goto yy170;
yy238:
	yych = *++YYCURSOR;
	if (yych == 'n') goto yy243;
	goto yy170;
yy239:
	yych = *++YYCURSOR;
	if (yych != 'c') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 260 "../snl.re"
	{ TYPEWORD(STRUCT,	"struct"); }
#line 1515 "lexer.c"
yy243:
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 259 "../snl.re"
	{ KEYWORD(STRING,	"string"); }
#line 1525 "lexer.c"
yy246:
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 258 "../snl.re"
	{ KEYWORD(STATE,	"state"); }
#line 1535 "lexer.c"
yy249:
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'f') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 256 "../snl.re"
	{ TYPEWORD(SIZEOF,	"sizeof"); }
#line 1549 "lexer.c"
yy254:
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 255 "../snl.re"
	{ TYPEWORD(SHORT,	"short"); }
#line 1561 "lexer.c"
yy258:
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
yy260:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych <= 'Z') {
		if (yych <= '/') goto yy262;
		if (yych <= '9') goto yy260;
		if (yych >= 'A') goto yy260;
	} else {
		if (yych <= '_') {
			if (yych >= '_') goto yy260;
		} else {
			if (yych <= '`') goto yy262;
			if (yych <= 'z') goto yy260;
		}
	}
yy262:
#line 279 "../snl.re"
	{
		*cursor = 0;
		scan_report(s, "identifier '%s'starts with reserved prefix\n", s->tok);
		DONE;
	}
#line 1590 "lexer.c"
yy263:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 254 "../snl.re"
	{ KEYWORD(RETURN,	"return"); }
#line 1606 "lexer.c"
yy269:
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 253 "../snl.re"
	{ KEYWORD(PROGRAM,	"program"); }
#line 1624 "lexer.c"
yy276:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 252 "../snl.re"
	{ KEYWORD(OPTION,	"option"); }
#line 1640 "lexer.c"
yy282:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'o') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 251 "../snl.re"
	{ KEYWORD(MONITOR,	"monitor"); }
#line 1658 "lexer.c"
yy289:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 250 "../snl.re"
	{ TYPEWORD(LONG,	"long"); }
#line 1670 "lexer.c"
yy293:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 248 "../snl.re"
	{ KEYWORD(IF,		"if"); }
#line 1678 "lexer.c"
yy295:
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '8') {
		if (yych <= '1') {
			if (yych <= '/') goto yy297;
			if (yych <= '0') goto yy169;
			goto yy298;
		} else {
			if (yych == '3') goto yy299;
			if (yych <= '7') goto yy169;
			goto yy300;
		}
	} else {
		if (yych <= '^') {
			if (yych <= '9') goto yy169;
			if (yych <= '@') goto yy297;
			if (yych <= 'Z') goto yy169;
		} else {
			if (yych == '`') goto yy297;
			if (yych <= 'z') goto yy169;
		}
	}
yy297:
#line 249 "../snl.re"
	{ TYPEWORD(INT,		"int"); }
#line 1706 "lexer.c"
yy298:
	yych = *++YYCURSOR;
	if (yych == '6') goto yy308;
	goto yy170;
yy299:
	yych = *++YYCURSOR;
	if (yych == '2') goto yy304;
	goto yy170;
yy300:
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 272 "../snl.re"
	{ TYPEWORD(INT8T,  	"int8_t"); }
#line 1726 "lexer.c"
yy304:
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 276 "../snl.re"
	{ TYPEWORD(INT32T, 	"int32_t"); }
#line 1738 "lexer.c"
yy308:
	yych = *++YYCURSOR;
	if (yych != '_') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 274 "../snl.re"
	{ TYPEWORD(INT16T, 	"int16_t"); }
#line 1750 "lexer.c"
yy312:
	yych = *++YYCURSOR;
	if (yych == 'o') goto yy321;
	goto yy170;
yy313:
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= '^') {
		if (yych <= '9') {
			if (yych >= '0') goto yy169;
		} else {
			if (yych <= '@') goto yy315;
			if (yych <= 'Z') goto yy169;
		}
	} else {
		if (yych <= 'd') {
			if (yych != '`') goto yy169;
		} else {
			if (yych <= 'e') goto yy316;
			if (yych <= 'z') goto yy169;
		}
	}
yy315:
#line 246 "../snl.re"
	{ KEYWORD(FOR,		"for"); }
#line 1777 "lexer.c"
yy316:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 247 "../snl.re"
	{ TYPEWORD(FOREIGN,	"foreign"); }
#line 1791 "lexer.c"
yy321:
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 245 "../snl.re"
	{ TYPEWORD(FLOAT,	"float"); }
#line 1803 "lexer.c"
yy325:
	yych = *++YYCURSOR;
	if (yych == 's') goto yy344;
	goto yy170;
yy326:
	yych = *++YYCURSOR;
	if (yych <= 's') goto yy170;
	if (yych <= 't') goto yy337;
	if (yych <= 'u') goto yy338;
	goto yy170;
yy327:
	yych = *++YYCURSOR;
	if (yych == 'f') goto yy332;
	goto yy170;
yy328:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 't') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 244 "../snl.re"
	{ KEYWORD(EXIT,		"exit"); }
#line 1829 "lexer.c"
yy332:
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 243 "../snl.re"
	{ TYPEWORD(EVFLAG,	"evflag"); }
#line 1843 "lexer.c"
yy337:
	yych = *++YYCURSOR;
	if (yych == 'r') goto yy341;
	goto yy170;
yy338:
	yych = *++YYCURSOR;
	if (yych != 'm') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 242 "../snl.re"
	{ TYPEWORD(ENUM,	"enum"); }
#line 1857 "lexer.c"
yy341:
	yych = *++YYCURSOR;
	if (yych != 'y') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 241 "../snl.re"
	{ KEYWORD(ENTRY,	"entry"); }
#line 1867 "lexer.c"
yy344:
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 240 "../snl.re"
	{ KEYWORD(ELSE,		"else"); }
#line 1877 "lexer.c"
yy347:
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'b') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'l') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 239 "../snl.re"
	{ TYPEWORD(DOUBLE,	"double"); }
#line 1893 "lexer.c"
yy353:
	yych = *++YYCURSOR;
	if (yych == 'a') goto yy365;
	goto yy170;
yy354:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych <= 'r') goto yy170;
	if (yych <= 's') goto yy356;
	if (yych <= 't') goto yy357;
	goto yy170;
yy356:
	yych = *++YYCURSOR;
	if (yych == 't') goto yy363;
	goto yy170;
yy357:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'u') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 238 "../snl.re"
	{ KEYWORD(CONTINUE,	"continue"); }
#line 1925 "lexer.c"
yy363:
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 237 "../snl.re"
	{ TYPEWORD(CONST,	"const"); }
#line 1933 "lexer.c"
yy365:
	yych = *++YYCURSOR;
	if (yych != 'r') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 236 "../snl.re"
	{ TYPEWORD(CHAR,	"char"); }
#line 1943 "lexer.c"
yy368:
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'a') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'k') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 235 "../snl.re"
	{ KEYWORD(BREAK,	"break"); }
#line 1957 "lexer.c"
yy373:
	yych = *++YYCURSOR;
	if (yych != 's') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'g') goto yy170;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy170;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 32) {
		goto yy169;
	}
#line 234 "../snl.re"
	{ KEYWORD(ASSIGN,	"assign"); }
#line 1973 "lexer.c"
yy379:
	++YYCURSOR;
#line 298 "../snl.re"
	{ OPERATOR(MODEQ,	"%="); }
#line 1978 "lexer.c"
yy381:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy381;
	}
#line 230 "../snl.re"
	{
				s->tok = s->end = cursor;
				goto c_code_line;
			}
#line 1991 "lexer.c"
yy384:
	++YYCURSOR;
#line 222 "../snl.re"
	{
				s->tok = cursor;
				in_c_code = 1;
#ifdef DEBUG
				report("in_c_code: cursor=%p, tok=%p\n", cursor, s->tok);
#endif
				goto c_code;
			}
#line 2003 "lexer.c"
yy386:
	++YYCURSOR;
#line 297 "../snl.re"
	{ OPERATOR(DIVEQ,	"/="); }
#line 2008 "lexer.c"
yy388:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy388;
	}
#line 221 "../snl.re"
	{ goto snl; }
#line 2018 "lexer.c"
yy391:
	++YYCURSOR;
#line 220 "../snl.re"
	{ goto comment; }
#line 2023 "lexer.c"
yy393:
	yyaccept = 4;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy393;
	} else {
		if (yych <= ' ') goto yy393;
		if (yych == 'l') goto yy396;
	}
yy395:
#line 212 "../snl.re"
	{
				line_marker_part = cursor - s->tok;
				goto line_marker;
			}
#line 2041 "lexer.c"
yy396:
	yych = *++YYCURSOR;
	if (yych != 'i') goto yy127;
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy127;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy127;
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy400;
	if (yych != ' ') goto yy127;
yy400:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '\t') goto yy400;
	if (yych == ' ') goto yy400;
	goto yy395;
yy402:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
yy403:
	if (yych <= '\f') {
		if (yych == '\t') goto yy402;
		if (yych <= '\n') goto yy5;
		goto yy83;
	} else {
		if (yych <= ' ') {
			if (yych <= 0x1F) goto yy5;
			goto yy402;
		} else {
			if (yych != '#') goto yy5;
		}
	}
	++YYCURSOR;
	if ((yych = *YYCURSOR) <= 0x1F) {
		if (yych == '\t') goto yy393;
		goto yy127;
	} else {
		if (yych <= ' ') goto yy393;
		if (yych == 'l') goto yy396;
		goto yy127;
	}
}
#line 339 "../snl.re"


string_const:

#line 2092 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		160, 160,  32,  32,  32,  32,  32,  32, 
		 32, 160, 160, 160, 160, 160, 160,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,   0,  32,  32,  32, 
		 32, 160, 160, 160, 160, 160, 160,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '!') {
		if (yych == '\n') goto yy413;
		goto yy408;
	} else {
		if (yych <= '"') goto yy411;
		if (yych == '\\') goto yy409;
		goto yy408;
	}
yy407:
#line 344 "../snl.re"
	{ goto string_const; }
#line 2143 "lexer.c"
yy408:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	goto yy415;
yy409:
	yyaccept = 1;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yybm[0+yych] & 64) {
		goto yy418;
	}
	if (yych <= 'e') {
		if (yych <= '>') {
			if (yych <= '"') {
				if (yych >= '"') goto yy414;
			} else {
				if (yych == '\'') goto yy414;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '?') goto yy414;
				if (yych >= '\\') goto yy414;
			} else {
				if (yych <= '`') goto yy410;
				if (yych <= 'b') goto yy414;
			}
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'n') {
				if (yych <= 'f') goto yy414;
				if (yych >= 'n') goto yy414;
			} else {
				if (yych == 'r') goto yy414;
			}
		} else {
			if (yych <= 'v') {
				if (yych != 'u') goto yy414;
			} else {
				if (yych == 'x') goto yy416;
			}
		}
	}
yy410:
#line 349 "../snl.re"
	{ scan_report(s, "invalid character in string constant\n"); DONE; }
#line 2189 "lexer.c"
yy411:
	++YYCURSOR;
#line 345 "../snl.re"
	{
				s->end = cursor - 1;
				goto string_cat;
			}
#line 2197 "lexer.c"
yy413:
	yych = *++YYCURSOR;
	goto yy410;
yy414:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy415:
	if (yybm[0+yych] & 32) {
		goto yy414;
	}
	if (yych <= '"') goto yy407;
	goto yy420;
yy416:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy421;
	}
yy417:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy407;
	} else {
		goto yy410;
	}
yy418:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy418;
	}
	if (yych <= '!') {
		if (yych == '\n') goto yy407;
		goto yy414;
	} else {
		if (yych <= '"') goto yy407;
		if (yych != '\\') goto yy414;
	}
yy420:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy418;
	}
	if (yych <= 'e') {
		if (yych <= '>') {
			if (yych <= '"') {
				if (yych <= '!') goto yy417;
				goto yy414;
			} else {
				if (yych == '\'') goto yy414;
				goto yy417;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '?') goto yy414;
				if (yych <= '[') goto yy417;
				goto yy414;
			} else {
				if (yych <= '`') goto yy417;
				if (yych <= 'b') goto yy414;
				goto yy417;
			}
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'n') {
				if (yych <= 'f') goto yy414;
				if (yych <= 'm') goto yy417;
				goto yy414;
			} else {
				if (yych == 'r') goto yy414;
				goto yy417;
			}
		} else {
			if (yych <= 'v') {
				if (yych == 'u') goto yy417;
				goto yy414;
			} else {
				if (yych == 'x') goto yy416;
				goto yy417;
			}
		}
	}
yy421:
	yyaccept = 0;
	YYMARKER = ++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy421;
	}
	if (yych <= '!') {
		if (yych == '\n') goto yy407;
		goto yy414;
	} else {
		if (yych <= '"') goto yy407;
		if (yych == '\\') goto yy420;
		goto yy414;
	}
}
#line 350 "../snl.re"


string_cat:

#line 2310 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= 0x1F) {
		if (yych <= 0x08) goto yy431;
		if (yych <= '\t') goto yy425;
		if (yych <= '\n') goto yy427;
		goto yy431;
	} else {
		if (yych <= ' ') goto yy425;
		if (yych == '"') goto yy429;
		goto yy431;
	}
yy425:
	++YYCURSOR;
	yych = *YYCURSOR;
	goto yy434;
yy426:
#line 354 "../snl.re"
	{ goto string_cat; }
#line 2366 "lexer.c"
yy427:
	++YYCURSOR;
#line 355 "../snl.re"
	{
				if (cursor == s->eof) {
					cursor -= 1;
					LITERAL(STRCON, string_literal, strdupft(s->tok, s->end));
				}
				s->line++;
				goto string_cat;
			}
#line 2378 "lexer.c"
yy429:
	++YYCURSOR;
#line 363 "../snl.re"
	{
				int len = s->end - s->tok;
				assert(len >= 0);
				memmove(cursor - len, s->tok, (size_t)len);
				s->tok = cursor - len;
				goto string_const;
			}
#line 2389 "lexer.c"
yy431:
	++YYCURSOR;
#line 370 "../snl.re"
	{
				cursor -= 1;
				LITERAL(STRCON, string_literal, strdupft(s->tok, s->end));
			}
#line 2397 "lexer.c"
yy433:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy434:
	if (yybm[0+yych] & 128) {
		goto yy433;
	}
	goto yy426;
}
#line 374 "../snl.re"


line_marker:

#line 2413 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,  64,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		 64,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '/') goto yy439;
	if (yych >= ':') goto yy439;
	++YYCURSOR;
	if (yybm[0+(yych = *YYCURSOR)] & 128) {
		goto yy443;
	}
	goto yy442;
yy438:
#line 378 "../snl.re"
	{
				s->line = atoi((char*)(s->tok + line_marker_part)) - 1;
				line_marker_part = cursor - s->tok;
				goto line_marker_str;
			}
#line 2466 "lexer.c"
yy439:
	++YYCURSOR;
#line 383 "../snl.re"
	{ goto line_marker_skip; }
#line 2471 "lexer.c"
yy441:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy442:
	if (yybm[0+yych] & 64) {
		goto yy441;
	}
	goto yy438;
yy443:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy441;
	}
	if (yych <= '/') goto yy438;
	if (yych <= '9') goto yy443;
	goto yy438;
}
#line 384 "../snl.re"


line_marker_str:

#line 2497 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,   0,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		224, 224, 224, 224, 224, 224, 224, 224, 
		160, 160,  32,  32,  32,  32,  32,  32, 
		 32, 160, 160, 160, 160, 160, 160,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,   0,  32,  32,  32, 
		 32, 160, 160, 160, 160, 160, 160,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
		 32,  32,  32,  32,  32,  32,  32,  32, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '\n') goto yy449;
	if (yych != '"') goto yy451;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych != '\n') goto yy453;
yy448:
#line 397 "../snl.re"
	{ goto line_marker_skip; }
#line 2543 "lexer.c"
yy449:
	++YYCURSOR;
#line 393 "../snl.re"
	{
				cursor -= 1;
				goto line_marker_skip;
			}
#line 2551 "lexer.c"
yy451:
	yych = *++YYCURSOR;
	goto yy448;
yy452:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy453:
	if (yybm[0+yych] & 32) {
		goto yy452;
	}
	if (yych <= '\n') goto yy454;
	if (yych <= '"') goto yy456;
	goto yy455;
yy454:
	YYCURSOR = YYMARKER;
	goto yy448;
yy455:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy459;
	}
	if (yych <= 'e') {
		if (yych <= '>') {
			if (yych <= '"') {
				if (yych <= '!') goto yy454;
				goto yy452;
			} else {
				if (yych == '\'') goto yy452;
				goto yy454;
			}
		} else {
			if (yych <= '\\') {
				if (yych <= '?') goto yy452;
				if (yych <= '[') goto yy454;
				goto yy452;
			} else {
				if (yych <= '`') goto yy454;
				if (yych <= 'b') goto yy452;
				goto yy454;
			}
		}
	} else {
		if (yych <= 's') {
			if (yych <= 'n') {
				if (yych <= 'f') goto yy452;
				if (yych <= 'm') goto yy454;
				goto yy452;
			} else {
				if (yych == 'r') goto yy452;
				goto yy454;
			}
		} else {
			if (yych <= 'v') {
				if (yych == 'u') goto yy454;
				goto yy452;
			} else {
				if (yych == 'x') goto yy458;
				goto yy454;
			}
		}
	}
yy456:
	++YYCURSOR;
#line 389 "../snl.re"
	{
				s->file = strdupft(s->tok + line_marker_part + 1, cursor-1);
				goto line_marker_skip;
			}
#line 2623 "lexer.c"
yy458:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy461;
	}
	goto yy454;
yy459:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 64) {
		goto yy459;
	}
	if (yych <= '!') {
		if (yych == '\n') goto yy454;
		goto yy452;
	} else {
		if (yych <= '"') goto yy456;
		if (yych == '\\') goto yy455;
		goto yy452;
	}
yy461:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy461;
	}
	if (yych <= '!') {
		if (yych == '\n') goto yy454;
		goto yy452;
	} else {
		if (yych <= '"') goto yy456;
		if (yych == '\\') goto yy455;
		goto yy452;
	}
}
#line 398 "../snl.re"


line_marker_skip:

#line 2668 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128,   0, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
		128, 128, 128, 128, 128, 128, 128, 128, 
	};
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy466;
	}
	goto yy468;
yy465:
#line 402 "../snl.re"
	{ goto snl; }
#line 2714 "lexer.c"
yy466:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy466;
	}
	goto yy465;
yy468:
	++YYCURSOR;
#line 403 "../snl.re"
	{ cursor -= 1; goto snl; }
#line 2727 "lexer.c"
}
#line 404 "../snl.re"


comment:

#line 2734 "lexer.c"
{
	YYCTYPE yych;
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych == '\n') goto yy475;
	if (yych != '*') goto yy474;
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '/') goto yy477;
yy473:
#line 409 "../snl.re"
	{ goto comment; }
#line 2746 "lexer.c"
yy474:
	yych = *++YYCURSOR;
	goto yy473;
yy475:
	++YYCURSOR;
#line 410 "../snl.re"
	{
				if (cursor == s->eof) {
					scan_report(s, "at eof: unterminated comment\n");
					DONE;
				}
				s->tok = cursor;
				s->line++;
				goto comment;
			}
#line 2762 "lexer.c"
yy477:
	++YYCURSOR;
#line 408 "../snl.re"
	{ goto snl; }
#line 2767 "lexer.c"
}
#line 419 "../snl.re"


c_code:

#line 2774 "lexer.c"
{
	YYCTYPE yych;
	unsigned int yyaccept = 0;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 7) YYFILL(7);
	yych = *YYCURSOR;
	if (yych <= ' ') {
		if (yych <= '\t') {
			if (yych <= 0x08) goto yy483;
			goto yy484;
		} else {
			if (yych <= '\n') goto yy486;
			if (yych <= 0x1F) goto yy483;
			goto yy484;
		}
	} else {
		if (yych <= '#') {
			if (yych <= '"') goto yy483;
			goto yy485;
		} else {
			if (yych != '}') goto yy483;
		}
	}
	++YYCURSOR;
	if ((yych = *YYCURSOR) == '%') goto yy501;
yy482:
#line 429 "../snl.re"
	{ goto c_code; }
#line 2836 "lexer.c"
yy483:
	yych = *++YYCURSOR;
	goto yy482;
yy484:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy499;
		goto yy482;
	} else {
		if (yych <= ' ') goto yy499;
		if (yych == '#') goto yy498;
		goto yy482;
	}
yy485:
	yyaccept = 0;
	yych = *(YYMARKER = ++YYCURSOR);
	if (yybm[0+yych] & 128) {
		goto yy488;
	}
	if (yych == 'l') goto yy491;
	goto yy482;
yy486:
	++YYCURSOR;
#line 434 "../snl.re"
	{
				if (cursor == s->eof) {
					scan_report(s, "at eof: unterminated literal c-code section\n");
					DONE;
				}
				s->line++;
				goto c_code;
			}
#line 2870 "lexer.c"
yy488:
	yyaccept = 1;
	YYMARKER = ++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 5) YYFILL(5);
	yych = *YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy488;
	}
	if (yych == 'l') goto yy491;
yy490:
#line 430 "../snl.re"
	{
				line_marker_part = cursor - s->tok;
				goto line_marker;
			}
#line 2886 "lexer.c"
yy491:
	yych = *++YYCURSOR;
	if (yych == 'i') goto yy493;
yy492:
	YYCURSOR = YYMARKER;
	if (yyaccept == 0) {
		goto yy482;
	} else {
		goto yy490;
	}
yy493:
	yych = *++YYCURSOR;
	if (yych != 'n') goto yy492;
	yych = *++YYCURSOR;
	if (yych != 'e') goto yy492;
	yych = *++YYCURSOR;
	if (yych == '\t') goto yy496;
	if (yych != ' ') goto yy492;
yy496:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
	if (yych == '\t') goto yy496;
	if (yych == ' ') goto yy496;
	goto yy490;
yy498:
	yych = *++YYCURSOR;
	if (yybm[0+yych] & 128) {
		goto yy488;
	}
	if (yych == 'l') goto yy491;
	goto yy492;
yy499:
	++YYCURSOR;
	if ((YYLIMIT - YYCURSOR) < 6) YYFILL(6);
	yych = *YYCURSOR;
	if (yych <= 0x1F) {
		if (yych == '\t') goto yy499;
		goto yy492;
	} else {
		if (yych <= ' ') goto yy499;
		if (yych == '#') goto yy498;
		goto yy492;
	}
yy501:
	++YYCURSOR;
#line 423 "../snl.re"
	{
#ifdef DEBUG
				report("c_code: tok=%p", s->tok);
#endif
				LITERAL(CCODE, embedded_c_code, strdupft(s->tok, cursor - 2));
			}
#line 2940 "lexer.c"
}
#line 442 "../snl.re"


c_code_line:

#line 2947 "lexer.c"
{
	YYCTYPE yych;
	static const unsigned char yybm[] = {
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0, 128,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		128,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
		  0,   0,   0,   0,   0,   0,   0,   0, 
	};
	if ((YYLIMIT - YYCURSOR) < 2) YYFILL(2);
	yych = *YYCURSOR;
	if (yych <= '\n') {
		if (yych <= 0x08) goto yy505;
		if (yych <= '\t') goto yy507;
		goto yy508;
	} else {
		if (yych == ' ') goto yy507;
	}
yy505:
	++YYCURSOR;
yy506:
#line 446 "../snl.re"
	{
				s->end = cursor;
				goto c_code_line;
			}
#line 3001 "lexer.c"
yy507:
	yych = *(YYMARKER = ++YYCURSOR);
	if (yych <= 0x08) goto yy506;
	if (yych <= '\n') goto yy511;
	if (yych == ' ') goto yy511;
	goto yy506;
yy508:
	++YYCURSOR;
#line 450 "../snl.re"
	{
				if (cursor == s->eof) {
					cursor -= 1;
				}
				s->line++;
				if (s->end > s->tok) {
					LITERAL(CCODE, embedded_c_code, strdupft(s->tok, s->end));
				}
				goto snl;
			}
#line 3021 "lexer.c"
yy510:
	++YYCURSOR;
	if (YYLIMIT <= YYCURSOR) YYFILL(1);
	yych = *YYCURSOR;
yy511:
	if (yybm[0+yych] & 128) {
		goto yy510;
	}
	if (yych <= 0x08) goto yy512;
	if (yych <= '\n') goto yy508;
yy512:
	YYCURSOR = YYMARKER;
	goto yy506;
}
#line 460 "../snl.re"

	DONE;		/* dead code, only here to make compiler warning go away */
}

Node *parse_program(FILE *in, const char *src_file)
{
	Scanner	s;
	int	tt;		/* token type */
	Token	tv;		/* token value */
	Node	*result;	/* result of parsing */
	void	*parser;	/* the (lemon generated) parser */

	memset(&s, 0, sizeof(s));
	s.file = src_file;
	s.line = 1;
	s.in = in;

	parser = snlParserAlloc(malloc);
	do
	{
		tt = scan(&s, &tv);
                tv.symbol = tt;
#ifdef	DEBUG
		report_at(tv.file, tv.line, "%2d\t$%s$\n", tt, tv.str);
#endif
		snlParser(parser, tt, tv, &result);
	}
	while (tt);
	snlParserFree(parser, free);
	return result;
}
